<template>
    <v-container>
	    <v-row v-if="messages.length != 0">
	    	<v-col cols="12" sm="3" md="4" v-for="message of messages" :key="message.id">
	    		<v-card>
	    			<v-toolbar dark color="#c51f2f" v-if="!message.done">
	    				<v-toolbar-title>De: Becas COZCyT</v-toolbar-title>
	    			</v-toolbar>
	    			<v-toolbar dark color="success" v-else>
	    				<v-toolbar-title>De: Becas COZCyT</v-toolbar-title>
	    			</v-toolbar>
	    			<v-card-text>
	    				<p class="body-1">{{message.sendDate}}</p>
	    				<p class="body-1">{{message.message}}</p>
	    			</v-card-text>
	    		</v-card>
	    	</v-col>
	    </v-row>
	    <v-row justify="center" v-else>
	    	<p class="headline">No tiene mensajes disponibles</p>
	    </v-row>
        <v-row justify="center">
            <v-col cols="12" sm="2">
                <v-btn color="info" block @click="$router.go(-1)">Regresar</v-btn>
            </v-col>
        </v-row>
        <Navigation />
    </v-container>
</template>

<script>
import gql from "graphql-tag";
import EventBus from "../../bus";
import Navigation from "@/components/Navigation";

export default {
    name: "MessagesStudent",
    components: { Navigation },
	data: () => ({
		messages: []
	}),
	methods: {
		// Obtiene los mensajes
		async getMessages() {
			try {
				const { data } = await this.$apollo.query({
					query: gql`
						query($curp: String!) {
							getAllMessages(curp: $curp) {
								messages {
									id
									sendDate
									message
									done
								}
							}
						}
					`,
					variables:{
						curp: this.$route.params.student
					}
				});
				this.messages = data.getAllMessages.messages;
				
				const meses = ["Enero", "Febrero", "Marzo", "Abril", "Mayo", "Junio", "Julio", "Agosto", "Septiembre", "Octubre", "Noviembre", "Diciembre"];
				this.messages = this.messages.map(messageData => {
					const id = messageData['id'];
					const message = messageData['message'];
					const done = messageData['done'];
					const date = messageData['sendDate'];
					let sendDate = new Date(parseInt(date));
					sendDate = `
						Fecha de recibido: ${sendDate.getDate()} 
						de ${meses[sendDate.getMonth()]} 
						del ${sendDate.getFullYear()} 
						a ${sendDate.getHours() === 1 ? "la" : "las"} 
						${sendDate.getHours()}:${(sendDate.getMinutes() < 10) ? `0${sendDate.getMinutes()}` :sendDate.getMinutes()}
					`;
					return { id, message, sendDate, done }
				})
			} catch (error) {}
		}
	},
	created() {
		this.getMessages();
	}
};
</script>